<?php

/**
 * Bootstrap File for Veristore Plugin
 */
class Shopware_Plugins_Frontend_aixVeristore_Bootstrap extends Shopware_Components_Plugin_Bootstrap
{
    /**
     * standard install method - subscribe an event
     * define destination of affialiatecode-installation
     * an define the site-id
     * @return bool
     */
    public function install()
    {
        //$this->subscribeEvent('Enlight_Controller_Action_PostDispatch', 'onPostDispatch');
        $this->subscribeEvents();
        $this->createForm();
        $this->createTranslations();

        return true;
    }

    /**
     * Returns the version of this plugin
     *
     * @return string
     */
    public function getVersion()
    {
        return '1.1.0';
    }


    public function getLabel()
    {
        return "Veristore";
    }

    /**
     * standard meta description
     * @return unknown
     */
    public function getInfo()
    {
        return include(dirname(__FILE__).'/Meta.php');
    }

    /**
     * Define template and variables
     * @param Enlight_Event_EventArgs $args
     */
    public function onPostDispatch(Enlight_Event_EventArgs $args)
    {
        //$request = $args->getSubject()->Request();
        //$response = $args->getSubject()->Response();

        $view = $args->getSubject()->View();
        $config = Shopware()->Plugins()->Frontend()->aixVeristore()->Config();
        /*if (!$request->isDispatched() || $response->isException() || $request->getModuleName() != 'frontend' || !$view->hasTemplate()) {
             return;
         }*/
        $view->AixVeristoreConfig = $config;
        $view->addTemplateDir($this->Path() . 'Views/');
        $view->extendsTemplate('frontend/plugins/aix_veristore/index.tpl');
        //$args->getSubject()->View()->extendsTemplate('frontend/plugins/aix_veristore/index.tpl');
    }

    protected function subscribeEvents()
    {
        $this->subscribeEvent('Enlight_Controller_Action_PostDispatch', 'onPostDispatch');
    }

    /**
     * Create form fields
     */
    protected function createForm()
    {
        $form = $this->Form();

        $form->setElement('text', 'aixVeristoreToken', array(
            'label' => 'Veristore-Token',
            'value' => 'dh4URozyzCLZxCdrmyra',
            'required' => true,
            'scope' => Shopware\Models\Config\Element::SCOPE_SHOP
        ));

        $form->setElement('select', 'aixVeristorePosition', array(
                'label' => 'Position des Widgets',
                'value' => 'right',
                'store' => array(
                        array('right', 'Rechts'),
                        array('left', 'Links'),
                ),
                'scope' => Shopware\Models\Config\Element::SCOPE_SHOP
        ));

        $form->setElement('select', 'aixVeristoreVariant', array(
            'label' => 'Größe des Widgets',
            'value' => 'medium',
            'store' => array(
                array('small', 'Klein'),
                array('medium', 'Groß'),
            ),
            'scope' => Shopware\Models\Config\Element::SCOPE_SHOP
        ));

        $form->setElement('text', 'aixVeristoreOffset', array(
            'label' => 'Abstand von unten in Pixeln',
            'value' => 120,
            'required' => true,
            'scope' => Shopware\Models\Config\Element::SCOPE_SHOP
        ));

        $form->setElement('boolean', 'aixVeristoreResponsive', array(
            'label' => 'Responsive',
            'value' => true,
            'scope' => Shopware\Models\Config\Element::SCOPE_SHOP
        ));
    }

    public function createTranslations()
    {
        $form = $this->Form();
        $translations = array(
            'en_GB' => array(
                'aixVeristoreToken'         => 'Veristore token',
                'aixVeristoreVariant'       => 'Widget size',
                'aixVeristoreOffset'        => 'Bottom offset in pixels',
                'aixVeristoreResponsive'    => 'Responsive',
                'aixVeristorePosition'      => 'Widget position'
            ),
            'en_US' => array(
                'aixVeristoreToken'         => 'Veristore token',
                'aixVeristoreVariant'       => 'Widget size',
                'aixVeristoreOffset'        => 'Bottom offset in pixels',
                'aixVeristoreResponsive'    => 'Responsive',
                'aixVeristorePosition'      => 'Widget position'
            )
        );

        $shopRepository = Shopware()->Models()->getRepository('\Shopware\Models\Shop\Locale');
        foreach ($translations as $locale => $snippets) {
            $localeModel = $shopRepository->findOneBy(array(
                'locale' => $locale
            ));
            //iterate all snippets of the current language
            foreach ($snippets as $element => $snippet) {
                //not found? continue with next language
                if ($localeModel === null) {
                    continue;
                }
                //get the form element by name
                $elementModel = $form->getElement($element);
                //not found? continue with next snippet
                if ($elementModel === null) {
                    continue;
                }
                //create new translation model
                $translationModel = new \Shopware\Models\Config\ElementTranslation();
                $translationModel->setLabel($snippet);
                $translationModel->setLocale($localeModel);
                //add the translation to the form element
                $elementModel->addTranslation($translationModel);
            }
        }
    }
}